/******************************************************************************
 * test_matrix2.c
 * Federico Bareilles
 * 18/08/2003
 *
 *
 *****************************************************************************/

#define _POSIX_SOURCE 1         /* POSIX compliant source  */

#include <stdio.h>
#include "matrix.h"


int main(void) /* only for test */
{
  struct matrix *M,*A,*B,*LU,*V,*X;
  double **a;
  double det;
  int v[3];
  
  M = B = A = NULL;
  A = make_matrix(3,3);
  V = make_matrix(3,1);
  a = A->M;

  a[0][0] =  2.;
  a[0][1] =  3.;
  a[0][2] =  3.;
  //a[0][3] =  6;
  //a[0][4] =  2;

  a[1][0] =  0.;
  a[1][1] =  5.;
  a[1][2] =  7.;
  //a[1][3] =  1;
  //a[1][4] =  1;

  a[2][0] =  6;
  a[2][1] =  9.;
  a[2][2] =  8.;
  //a[2][3] =  1;
  //a[2][4] =  0;
  /*
  a[3][0] =  0;
  a[3][1] =  0;
  a[3][2] =  4;
  a[3][3] =  0;
  a[3][4] =  2;

  a[4][0] =  2;
  a[4][1] =  4;
  a[4][2] =  3;
  a[4][3] =  2;
  a[4][4] =  2;
  */
  V->M[0][0] = 2.;
  V->M[1][0] = 2.;
  V->M[2][0] = 5.;


  //  M = prod_matrix(A,B);
  print_matrix(A);
  det = det_matrix(A);
  printf("Det = %f\n", det);
  if(det){
    M = inv_matrix(A);
    print_matrix(M);
  }
  
  if(M != NULL){
    print_matrix(M);
    B = prod_matrix(A,M);
    print_matrix(B);
  }
  /*
  printf("LU Factorization:\n");
  //LU = LU_factorization(A,v);
  LU = LU_factorization(A, v);
  print_matrix(LU);
  LU_fact_vector(LU, V, v);
  print_matrix(V);
  X = LU_back_substitution(LU, V, v);
  */
  //X = LU_linear_resolv(A, V);
  X = LU_inv_matrix(A);

  print_matrix(X);
  //B = prod_matrix(A,LU);
  //print_matrix(B);


  free_matrix(A);
  free_matrix(B);
  free_matrix(M);
  free_matrix(X);
  //free_matrix(LU);
  return 0;
}
